demosplan/DemosPlanCoreBundle/Entity/Branding.php
<?php

/**
 * This file is part of the package demosplan.
 *
 * (c) 2010-present DEMOS plan GmbH, for more information see the license file.
 *
 * All rights reserved
 */

namespace demosplan\DemosPlanCoreBundle\Entity;

use DemosEurope\DemosplanAddon\Contracts\Entities\BrandingInterface;
use DemosEurope\DemosplanAddon\Contracts\Entities\FileInterface;
use DemosEurope\DemosplanAddon\Contracts\Entities\UuidEntityInterface;
use demosplan\DemosPlanCoreBundle\Repository\BrandingRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=BrandingRepository::class)
 */
class Branding extends CoreEntity implements UuidEntityInterface, BrandingInterface
{
    /**
     * @var string|null
     *
     * @ORM\Id
     *
     * @ORM\Column(type="string", length=36, nullable=false, options={"fixed":true})
     *
     * @ORM\GeneratedValue(strategy="CUSTOM")
     *
     * @ORM\CustomIdGenerator(class="\demosplan\DemosPlanCoreBundle\Doctrine\Generator\UuidV4Generator")
     */
    protected $id;

    /**
     * For future reference: null is for all intents and purposes equivalent to ''.
     * Both mean that there is no set of cssvars.
     *
     * @var ?string
     *
     * @ORM\Column(type="text", nullable=true)
     */
    protected $cssvars;

    /**
     * @var FileInterface|null
     *
     * @ORM\OneToOne(targetEntity="demosplan\DemosPlanCoreBundle\Entity\File")
     *
     * @ORM\JoinColumn(name="logo", referencedColumnName="_f_ident", nullable=true, onDelete="CASCADE")
     */
    protected $logo;

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getCssvars(): ?string
    {
        return $this->cssvars;
    }

    public function setCssvars(?string $cssVars): self
    {
        $this->cssvars = $cssVars;

        return $this;
    }

    public function getLogo(): ?File
    {
        return $this->logo;
    }

    public function setLogo(?FileInterface $logo): void
    {
        $this->logo = $logo;
    }
}

demosplan/DemosPlanCoreBundle/Entity/CoreEntity.php
<?php

/**
 * This file is part of the package demosplan.
 *
 * (c) 2010-present DEMOS plan GmbH, for more information see the license file.
 *
 * All rights reserved
 */

namespace demosplan\DemosPlanCoreBundle\Entity;

use DemosEurope\DemosplanAddon\Contracts\Entities\CoreEntityInterface;

class CoreEntity implements CoreEntityInterface
{
    /**
     * The Database field to store content change of an Entity, is modeled as "text".
     * Therefore string, int or bool can be (casted and) stored.
     *
     * At least the ID of the object will be returned.
     *
     * @return string|int|bool
     */
    public function getEntityContentChangeIdentifier()
    {
        if (method_exists($this, 'getDisplayId')) {
            return $this->getDisplayId();
        }

        if (method_exists($this, 'getExternId')) {
            return $this->getExternId();
        }

        if (method_exists($this, 'getName')) {
            return $this->getName();
        }

        if (method_exists($this, 'getTitle')) {
            return $this->getTitle();
        }

        if (method_exists($this, 'getId')) {
            return $this->getId();
        }

        return '';
    }

    /*
     *
     * When you try to extend CoreEntity from demosplan\DemosPlanCoreBundle\Logic\ArrayObject:
     *                              HERE BE DRAGONS
     *
     * When overriding serialize() and unserialize() to return empty values
     * I see e.g. the effect, that doctrine returns only organisationIds attached
     * by ManyToMany to Procedure instead of Objects on second request
     *
     * When not overriding serialize() and unserialize() the effect is, that on serializing the session
     * the fatal error "You cannot serialize or unserialize PDO instances" occurs
     */
}

demosplan/DemosPlanCoreBundle/Entity/Document/Elements.php
<?php

/**
 * This file is part of the package demosplan.
 *
 * (c) 2010-present DEMOS plan GmbH, for more information see the license file.
 *
 * All rights reserved
 */

namespace demosplan\DemosPlanCoreBundle\Entity\Document;

use DateTime;
use DemosEurope\DemosplanAddon\Contracts\Entities\ElementsInterface;
use DemosEurope\DemosplanAddon\Contracts\Entities\OrgaInterface;
use DemosEurope\DemosplanAddon\Contracts\Entities\ProcedureInterface;
use DemosEurope\DemosplanAddon\Contracts\Entities\UuidEntityInterface;
use demosplan\DemosPlanCoreBundle\Entity\CoreEntity;
use demosplan\DemosPlanCoreBundle\Entity\Procedure\Procedure;
use demosplan\DemosPlanCoreBundle\Entity\User\Orga;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * @ORM\Table(name="_elements")
 *
 * @ORM\Entity(repositoryClass="demosplan\DemosPlanCoreBundle\Repository\ElementsRepository")
 */
class Elements extends CoreEntity implements UuidEntityInterface, ElementsInterface
{
    /**
     * @var string|null
     *
     * @ORM\Column(name="_e_id", type="string", length=36, options={"fixed":true})
     *
     * @ORM\Id
     *
     * @ORM\GeneratedValue(strategy="CUSTOM")
     *
     * @ORM\CustomIdGenerator(class="\demosplan\DemosPlanCoreBundle\Doctrine\Generator\UuidV4Generator")
     */
    protected $id;

    /**
     * @var string|null
     *
     * @ORM\Column(name="_e_p_id", type="string", length=36, options={"fixed":true}, nullable=true)
     */
    protected $elementParentId;

    /**
     * @var ElementsInterface|null
     *
     * @ORM\ManyToOne(targetEntity="demosplan\DemosPlanCoreBundle\Entity\Document\Elements", inversedBy="children")
     *
     * @ORM\JoinColumn(name="_e_p_id", referencedColumnName="_e_id", onDelete="SET NULL")
     */
    protected $parent;

    /**
     * @var string
     *
     * @ORM\Column(name="_p_id", type="string", length=36, options={"fixed":true}, nullable=false)
     */
    protected $pId;

    /**
     * Das Procedure
     * T4999 cascade={"persist"} needed because of doctrine fuckup when deleting procedures (!).
     *
     * @var Procedure
     *
     * @ORM\ManyToOne(targetEntity="\demosplan\DemosPlanCoreBundle\Entity\Procedure\Procedure", inversedBy="elements", cascade={"persist"})
     *
     * @ORM\JoinColumn(name="_p_id", referencedColumnName="_p_id", onDelete="CASCADE")
     */
    protected $procedure;

    /**
     * @var string
     *
     * @ORM\Column(name="_e_category", type="string", length=36, options={"fixed":true}, nullable=false)
     */
    protected $category = '';

    /**
     * @var string
     *
     * @ORM\Column(name="_e_title", type="string", length=256, nullable=false)
     */
    protected $title = '';

    /**
     * @var string
     *
     * @ORM\Column(name="_e_icon", type="string", length=36, nullable=false)
     */
    protected $icon = '';

    /**
     * @var string
     *
     * @ORM\Column(name="_e_icon_title", type="string", options={"comment":"Content of title-tag for icon"})
     */
    protected $iconTitle = '';

    /**
     * @var string
     *
     * @ORM\Column(name="_e_text", type="text", length=65535, nullable=false)
     */
    protected $text = '';

    /**
     * @var string
     *
     * @ORM\Column(name="_e_file", type="string", length=256, nullable=false, options={"default":""})
     */
    protected $file = '';

    /**
     * @var int
     *
     * @ORM\Column(name="_e_order", type="integer", nullable=false)
     */
    protected $order;

    /**
     * @var bool
     *
     * @ORM\Column(name="_e_enabled", type="boolean", nullable=false, options={"default":true})
     */
    protected $enabled = true;

    /**
     * @var bool
     *
     * @ORM\Column(name="_e_deleted", type="boolean", nullable=false, options={"default":false})
     */
    protected $deleted = false;

    /**
     * @var DateTime
     *
     * @Gedmo\Timestampable(on="create")
     *
     * @ORM\Column(name="_e_create_date", type="datetime", nullable=false)
     */
    protected $createDate;

    /**
     * @var DateTime
     *
     * @Gedmo\Timestampable(on="update")
     *
     * @ORM\Column(name="_e_modify_date", type="datetime", nullable=false)
     */
    protected $modifyDate;

    /**
     * @var DateTime
     *
     * @Gedmo\Timestampable(on="create")
     *
     * @ORM\Column(name="_e_delete_date", type="datetime", nullable=false)
     */
    protected $deleteDate;

    /**
     * @var Collection<int,SingleDocument>
     *
     * @ORM\OneToMany(targetEntity="demosplan\DemosPlanCoreBundle\Entity\Document\SingleDocument", mappedBy="element")
     *
     * @ORM\OrderBy({"order" = "ASC", "createDate" = "ASC"})
     */
    protected $documents;

    /**
     * @var Collection<int,Elements>
     *
     * @ORM\OneToMany(targetEntity="demosplan\DemosPlanCoreBundle\Entity\Document\Elements", mappedBy="parent")
     *
     * @ORM\OrderBy({"order" = "ASC"})
     */
    protected $children;

    /**
     * @var Collection<int,Orga>|Orga[]
     *
     * @ORM\ManyToMany(targetEntity="demosplan\DemosPlanCoreBundle\Entity\User\Orga")
     *
     * @ORM\JoinTable(
     *     name="_elements_orga_doctrine",
     *     joinColumns={@ORM\JoinColumn(name="_e_id", referencedColumnName="_e_id", onDelete="CASCADE")},
     *     inverseJoinColumns={@ORM\JoinColumn(name="_o_id", referencedColumnName="_o_id", onDelete="CASCADE")}
     * )
     */
    protected $organisations;

    /**
     * @var mixed
     */
    protected $type;

    /**
     * @var DateTime|null
     *
     * @ORM\Column(name = "_e_designated_switch_date", type = "datetime", nullable = true)
     */
    protected $designatedSwitchDate;

    /**
     * @var string|null
     *
     * @ORM\Column(type = "string", nullable = true, options={"default":null, "comment":"Needed permission, to get this element."})
     */
    protected $permission;

    public function __construct()
    {
        $this->children = new ArrayCollection();
        $this->organisations = new ArrayCollection();
        $this->documents = new ArrayCollection();
    }

    public function getId(): ?string
    {
        return $this->id;
    }

    /**
     * @deprecated use {@link Elements::getId()} instead
     */
    public function getIdent(): ?string
    {
        return $this->getId();
    }

    /**
     * Set parent ElementId.
     */
    public function setElementParentId(?string $parentId): self
    {
        $this->elementParentId = $parentId;

        return $this;
    }

    /**
     * Set parent element.
     */
    public function setParent(?ElementsInterface $parent): void
    {
        $this->parent = $parent;
    }

    /**
     * Get parent element.
     */
    public function getParent(): ?Elements
    {
        return $this->parent;
    }

    /**
     * Get the Id of the related ParentElement.
     */
    public function getElementParentId(): ?string
    {
        return $this->elementParentId;
    }

    /**
     * Set pId.
     */
    public function setPId(string $pId): self
    {
        $this->pId = $pId;

        return $this;
    }

    /**
     * Get pId.
     *
     * @return string
     *
     * @deprecated this methods name is misleading (parent vs procedure), use
     *             {@link Elements::getProcedure()} instead
     */
    public function getPId()
    {
        if (is_null($this->pId) && $this->procedure instanceof Procedure) {
            $this->pId = $this->procedure->getId();
        }

        return $this->pId;
    }

    public function getProcedure(): Procedure
    {
        return $this->procedure;
    }

    /**
     * @return $this
     */
    public function setProcedure(ProcedureInterface $procedure): self
    {
        $this->procedure = $procedure;
        $this->pId = $procedure->getId();

        return $this;
    }

    /**
     * Set eCategory.
     */
    public function setCategory(string $category): self
    {
        $this->category = $category;

        return $this;
    }

    /**
     * Get eCategory.
     */
    public function getCategory(): string
    {
        return $this->category;
    }

    /**
     * Set eTitle.
     */
    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    /**
     * Get eTitle.
     */
    public function getTitle(): string
    {
        return $this->title;
    }

    /**
     * Set eIcon.
     */
    public function setIcon(string $icon): self
    {
        $this->icon = $icon;

        return $this;
    }

    /**
     * Get eIcon.
     */
    public function getIcon(): string
    {
        return $this->icon;
    }

    /**
     * Set eText.
     */
    public function setText(string $text): self
    {
        $this->text = $text;

        return $this;
    }

    /**
     * Get eText.
     */
    public function getText(): string
    {
        return $this->text;
    }

    public function getFile(): string
    {
        return $this->file;
    }

    public function setFile(string $file): void
    {
        $this->file = $file;
    }

    /**
     * Set eOrder.
     */
    public function setOrder(int $order): self
    {
        $this->order = $order;

        return $this;
    }

    /**
     * Get eOrder.
     */
    public function getOrder(): int
    {
        return $this->order;
    }

    /**
     * Set eEnabled.
     */
    public function setEnabled(bool $enabled): self
    {
        $this->enabled = $enabled;

        return $this;
    }

    /**
     * Get eEnabled.
     */
    public function getEnabled(): bool
    {
        return $this->enabled;
    }

    /**
     * Set eDeleted.
     */
    public function setDeleted(bool $deleted): self
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * Get eDeleted.
     */
    public function getDeleted(): bool
    {
        return $this->deleted;
    }

    /**
     * Set eCreateDate.

demosplan/DemosPlanCoreBundle/Entity/EmailAddress.php
<?php

declare(strict_types=1);

/**
 * This file is part of the package demosplan.
 *
 * (c) 2010-present DEMOS plan GmbH, for more information see the license file.
 *
 * All rights reserved
 */

namespace demosplan\DemosPlanCoreBundle\Entity;

use DemosEurope\DemosplanAddon\Contracts\Entities\EmailAddressInterface;
use DemosEurope\DemosplanAddon\Contracts\Entities\UuidEntityInterface;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Reasons for this entity:
 * - central place to use email address validations (eg. using annotations)
 * - getting all email addresses of all entities if needed (assumed the entity is actually used
 *   instead of a string field)
 * - if more logic is put into entity classes then email address related logic can be put here
 * - separate fields for local part and domain part possible (extendable)
 * - avoids using JSON (or doctrine arrays) in the database in case of to-many cardinalities
 * - normalization in general.
 *
 * Make sure to extend {@link EmailAddressRepository::deleteOrphanEmailAddresses} so that orphan
 * email addresses are removed to not keep personal data in the database without need.
 *
 * @ORM\Entity(repositoryClass="demosplan\DemosPlanCoreBundle\Repository\EmailAddressRepository")
 */
class EmailAddress extends CoreEntity implements UuidEntityInterface, EmailAddressInterface
{
    /**
     * @var string|null
     *
     * @ORM\Column(type="string", length=36, options={"fixed":true})
     *
     * @ORM\Id
     *
     * @ORM\GeneratedValue(strategy="CUSTOM")
     *
     * @ORM\CustomIdGenerator(class="\demosplan\DemosPlanCoreBundle\Doctrine\Generator\UuidV4Generator")
     */
    protected $id;

    /**
     * The full email address containing the local part and domain name.
     * Not the so-called display name.
     *
     * @var string
     *
     * @ORM\Column(type="string", length=254, nullable=false, unique=true)
     */
    #[Assert\NotBlank(allowNull: false)]
    #[Assert\Email(mode: 'strict')]
    protected $fullAddress;

    public function getId(): ?string
    {
        return $this->id;
    }

    public function setId(string $id): void
    {
        $this->id = $id;
    }

    public function getFullAddress(): string
    {
        return $this->fullAddress;
    }

    public function setFullAddress(string $fullAddress)
    {
        $this->fullAddress = $fullAddress;
    }
}

demosplan/DemosPlanCoreBundle/Entity/FacetFilterList.php
<?php

/**
 * This file is part of the package demosplan.
 *
 * (c) 2010-present DEMOS plan GmbH, for more information see the license file.
 *
 * All rights reserved
 */

namespace demosplan\DemosPlanCoreBundle\Entity;

class FacetFilterList
{
    /**
     * @var array Filter
     */
    protected $list = [];

    /**
     * @var array Filter
     */
    protected $activeFiltersList = [];

    /**
     * @return array
     */
    public function getList()
    {
        return $this->list;
    }

    /**
     * @return array
     */
    public function getActiveFiltersList()
    {
        return $this->activeFiltersList;
    }

    public function addFilter(FacetFilter $filter)
    {
        if ($filter->isActive()) {
            $this->activeFiltersList[$filter->getFilterName()] = $filter->getValue();
        }

        // Der Filter ist noch gar nicht in der Liste
        $filterSet = isset($this->list[$filter->getFilterName()]);
        $entitySet = isset($this->list[$filter->getFilterName()][$filter->getEntityId()]);
        if (!$filterSet || !$entitySet) {
            $filter->setCount(1);
            $this->list[$filter->getFilterName()][$filter->getEntityId()] = $filter;

            return;
        }

        // Der Filter ist registriert, erhöhe den Count um einen
        if (true === $entitySet) {
            $filter = $this->list[$filter->getFilterName()][$filter->getEntityId()];
            $filter->setCount($filter->getCount() + 1);
        }
    }
}

templates/bundles/DemosPlanCoreBundle/DemosPlanUser/citizen_register_form.html.twig
{% extends '@DemosPlanCore/DemosPlanCore/base_oeb.html.twig' %}

{% block component_part %}

    {% embed '@DemosPlanCore/DemosPlanCore/includes/participation_area_skeleton.html.twig' with {
        content_heading: 'register'|trans
    }%}
        {% block content %}
            <citizen-register-form
                :is-saml="{{ useSaml|json_encode }}"
                :saml-login-path="{{ path('saml_login')|json_encode }}"
                :csrf-token="{{ csrf_token('register-user')|json_encode }}">
                {{ extensionPointMarkup('formExtraFields')|raw }}
            </citizen-register-form>
        {% endblock content %}

    {% endembed %}

{% endblock %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundles(['user-citizenRegisterForm.js']) }}
{% endblock javascripts %}

templates/bundles/DemosPlanCoreBundle/DemosPlanUser/edit_department.html.twig
{% extends '@DemosPlanCore/DemosPlanCore/base.html.twig' %}

{% block component_part %}

{% endblock %}

templates/bundles/DemosPlanCoreBundle/DemosPlanUser/edit_orga_branding.html.twig
{% extends '@DemosPlanCore/DemosPlanCore/base_oeb.html.twig' %}

{% set organisation = templateVars.orga|default %}

{% block component_part %}
    {% embed '@DemosPlanCore/DemosPlanCore/includes/participation_area_skeleton.html.twig' with {
        'content_heading': "organisation.procedures.branding"|trans,
        'content_subheading': "text.organisation.branding.edit"|trans,
    }%}
        {% block content %}

            <form
                class="layout u-mt"
                action="{{ path('DemosPlan_orga_branding_edit', {'orgaId': organisation.ident|default}) }}"
                method="post"
                enctype="multipart/form-data">
                <div class="layout__item u-1-of-2 u-pr">
                    {{ fileupload(
                        'r_orgaLogo',
                        'organisation.logo.label',
                        ['.jpg', '.jpeg', '.png', '.gif'],
                        'form.button.upload.file',
                        1,
                        false,
                        'explanation.upload.logo.dimensions',
                        false,
                        '',
                        '0',
                        51200
                    )
                    }}
                </div><!--
             --><div class="layout__item u-1-of-2">
                    {% if templateVars.orga.logo is defined and templateVars.orga.logo is not null %}
                        <p class="weight--bold">{{ 'logo.current'|trans }}</p>
                        <img
                            src="{{ path("core_logo", { 'hash': templateVars.orga.logo.hash }) }}"
                            alt="{{ 'logo.alt.orga'|trans }}"
                            style="max-width: 300px;">
                        <div class="u-mt">
                            <input type="checkbox" id="delete_logo" name="r_logoDelete" value="deleteLogo"/>
                            <label for="delete_logo" class="inline-block weight--normal">
                                {{ 'logo.delete'|trans }}
                            </label>
                        </div>
                    {% endif %}
                </div>

                <fieldset class="text-right space-inline-s">
                    <button
                        type="submit"
                        class="btn btn--primary"
                    >
                        {{ 'save'|trans }}
                    </button>
                    <a
                        class="btn btn--secondary"
                        href="{{ path('DemosPlan_orga_edit_view', {'orgaId': organisation.ident|default()}) }}"
                    >
                        {{ "abort"|trans }}
                    </a>
                </fieldset>
            </form>

        {% endblock content %}
    {% endembed %}
{% endblock component_part %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundles(['user-editOrgaBranding.js']) }}
{% endblock javascripts %}

templates/bundles/DemosPlanCoreBundle/DemosPlanUser/list_departments.html.twig
{% extends '@DemosPlanCore/DemosPlanCore/base.html.twig' %}

{% block component_part %}
    <h1>
        {{ templateVars.organisation.name|default() }} : {{ "departments.administer"|trans }}
    </h1>
    <p class="font-size-small">
        {{ "text.department.edit"|trans }}
    </p>

    {% if templateVars.orgaList is defined and templateVars.orgaList == true and templateVars.orgaList|length > 0 %}
        <form action="{{ path('DemosPlan_department_list', {'orgaId': templateVars.organisation.ident})}}" method="post">
            <label class="push--bottom">
                <p class="u-mb-0_25">
                    {{ "organisation"|trans }}
                </p>
                <select
                    class="u-1-of-2 bg-color--white"
                    name="orgaId"
                    style="height: 28px;"
                    data-cy="OrgaSelectMenu">
                    {%  for orga in templateVars.orgaList %}
                        <option value="{{ orga.ident }}" {% if orga.ident == templateVars.organisation.ident %}selected{% endif %}>{{orga.name }}</option>
                    {% endfor %}
                </select>
                <input
                    class="btn btn--primary float-right"
                    type="submit"
                    value="{{ "organisation.switch"|trans }}"
                    data-cy="changeOrganization">
            </label>
        </form>
    {% endif %}

    <form
        class="push--top"
        id="departmentlist"
        action="{{ path('DemosPlan_department_add',{'orgaId': templateVars.organisation.ident}) }}"
        method="post">
        <input
            type="hidden"
            name="orgaId"
            value="{{ templateVars.organisation.ident|default() }}">

        <dp-accordion
            title="{{ "department.create"|trans }}"
            data-cy="newDepartmentToggle"
            ref="accordion-new-department">
            <div class="o-box--dark soft u-mb-0_5">
                <label
                    for="departmentName"
                    class="u-pt-0_5 u-mb-0 u-ml-0_5">
                    {{ "department.name"|trans }}*
                </label>
                <input
                    class="grid__item u-ml-0_5 u-1-of-2"
                    style="height: 28px;"
                    id="departmentName"
                    name="name"
                    type="text"
                    value=""
                    data-cy="newDepartment">

                <div class="text-right u-mt-0_5 u-mr-0_5 space-inline-s">
                    <input
                        class="btn btn--primary"
                        type="submit"
                        value="{{ "save"|trans }}"
                        data-cy="saveNewDepartment">
                    <input
                        class="btn btn--secondary color--white"
                        type="reset"
                        @click="$refs['accordion-new-department'].toggle(false)"
                        value="{{ "abort"|trans }}">
                </div>
            </div>
        </dp-accordion>
    </form>


    {% if feedback.success_message is defined %}
        <p class="flash flash-confirm">
            <i class="fa fa-check-circle" aria-hidden="true"></i>
            {{ feedback.success_message }}
        </p>
    {% endif %}
    {% if feedback.fail_message is defined %}
        <p class="flash flash-error">
            {% for message in feedback.fail_message %}
                <i class="fa fa-exclamation-circle" aria-hidden="true"></i>
                {{ message }}
                <br>
            {% endfor %}
        </p>
    {% endif %}

    {% if templateVars.departmentList == true %}
        <form
            class="push--top"
            action="{{ path('DemosPlan_departments_admin', { orgaId: templateVars.organisation.ident } ) }}"
            method="post"
            name="departmentsList">

            <div class="u-mt u-mb-0_5 layout">
                {% if hasPermission('feature_department_delete') %}
                    <div class="layout__item u-3-of-7">
                        <input
                            type="checkbox"
                            id="select_all"
                            name="checkAllItems"
                            value=""
                            data-form-actions-check-all
                            data-cy="selectAllDepartmentsList">
                        <label
                            for="select_all"
                            class="u-pl-0_125 btn-icns u-nojs-hide--inline-block">
                            {{ "departments.mark"|trans }}
                        </label>
                    </div><!--
              -->{% endif %}<!--
              --><div class="text-right layout__item {% if hasPermission('feature_department_delete') %}u-4-of-7 {% endif %}space-inline-s">
                    <button type="submit" class="btn btn--primary" name="manageDepartments" value="saveAll">
                        {{ 'save.all.changes'|trans }}
                    </button><!--

                  -->{% if hasPermission('feature_department_delete') %}<!--
                      --><button
                            type="submit"
                            class="btn btn--warning"
                            data-cy="deleteSelectedItem"
                            name="manageDepartments"
                            data-form-actions-confirm-value="deleteSelected"
                            data-form-actions-confirm="{{ 'check.entries.marked.delete'|trans }}"
                        >
                            {{ 'departments.marked.delete'|trans }}
                        </button><!--
                  -->{% endif %}<!--
               --></div>
            </div>

            <ul class="o-list o-list--card">
                {% for department in templateVars.departmentList %}
                    <dp-table-card
                        data-cy="departmentList"
                        class="o-list__item u-p-0_5 u-pl-0"
                        ref="table-card-{{ department.ident }}">
                        <template v-slot:header="">
                            <div class="layout__item">
                                {% if hasPermission('feature_department_delete') %}
                                    <input
                                        type="checkbox"
                                        name="elementsToAdminister[]"
                                        value="{{ department.ident|default }}"
                                        data-checkable-item
                                        data-cy="checkDepartmentList">
                                {% endif %}
                                <span class="weight--bold">
                                    {{ department.name|default }}
                                </span>
                                <div
                                    class="float-right inline-block weight--bold u-mr-0_5">
                                    <button
                                        @click="$refs['table-card-{{ department.ident }}'].toggle()"
                                        type="button"
                                        data-cy="editDepartmentToggle"
                                        class="btn--blank o-link--default">
                                        <i class="fa fa-angle-down" style="font-size: 1.8rem; line-height: 1.2rem;" aria-hidden="true"></i>
                                    </button>
                                </div>
                            </div>
                        </template>
                        <aside class="layout__item">
                            <label class="u-mv-0_5">
                                <p class="u-mb-0_25">
                                    {{ "department.name"|trans }}*
                                </p>
                                <input
                                    class="layout__item u-1-of-2"
                                    style="height: 28px;"
                                    name="{{ department.ident }}:name"
                                    type="text"
                                    value="{{ department.name|default() }}"
                                    data-cy="editDepartment">
                            </label>

                            <div class="text-right space-inline-s">
                                <button
                                    class="btn btn--primary"
                                    type="submit"
                                    name="manageDepartments"
                                    value="save:{{ department.ident|default() }}"
                                    data-cy="saveEditDepartment">
                                    {{ "save"|trans }}
                                </button>
                                <input
                                    class="btn btn--secondary color--white"
                                    type="reset"
                                    value="{{ "abort"|trans }}"
                                    @click="$refs['table-card-{{ department.ident }}'].toggle(false)">
                            </div>

                        </aside>

                    </dp-table-card>

                {% endfor %}
            </ul>

            <div class="layout u-mt">
                {% include '@DemosPlanCore/DemosPlanUser/includes/list_controls.html.twig' with {'controlName' : 'manageDepartments', 'entityName': 'Abteilung'} only %}
            </div>
        </form>
    {% endif %}
{% endblock %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundle('user-listDepartments.js')}}
{% endblock javascripts %}